#ifndef _GRAPHICS_H
#define _GRAPHICS_H
#include <allegro.h>

typedef struct
{ BITMAP **sprites;
  int nsprites;
} spriteset;

typedef struct
{ BITMAP **tiles;
  int *type;
  int ntiles;
} tileset;

enum
{ BLOCKING=0,
  UNBLOCKING=1,
  ONEWAYLEFT=2,
  ONEWAYRIGHT=3
};

extern BITMAP *vscreen;
extern RGB palette[];

extern spriteset spritesets[256];
extern tileset tilesets[256];

void d_sprite(BITMAP *dest, int set, int num, int x, int y);
void printfxy(int x, int y, char *fmt, ...);
void flush();
void drawscreen(int x, int y, int drawbackground,
                              int drawlayer0, int drawlayer1);
void loadtiles();
void loadsprites();
void loadtranstable();
void loadbackground();

#endif
