#include "input.h"
#include "map.h"
#include "misc.h"

char demoname[256];
FILE *demo;
int demostat=0;
char keys[128];

void writedemo()
{ static int ticks=0;
  static char old[128];
  int i;

  for(i=0; i<128; i++)
    if(old[i]!=keys[i])
    { if(ticks)
      { if(ticks>65535)
        { writechar(129, demo);
          writelong(ticks, demo);
        }
        else if(ticks>255)
        { writechar(130, demo);
          writeword(ticks, demo);
        }
        else
        { writechar(131, demo);
          writechar(ticks, demo);
        }
        ticks=0;
      }      
      writechar(i, demo);
      old[i]=keys[i];
    }

  ticks++;
}
   
void readdemo()
{ static int ticks=1;
  static char endofdemo=0;
  unsigned char c;

  debuglog("ticks: %d\n", ticks);
  if(endofdemo) return;

  ticks--;
  while(!ticks)
  { c=readchar(demo);
    debuglog("democommand: %d\n", c);
    if(c<129)
    { keys[c]=!keys[c];
      debuglog("KEY%d: %s\n", c, keys[c]?"DOWN":"UP");
    }
    else if(c==129) ticks=readlong(demo);
    else if(c==130) ticks=readword(demo);
    else if(c==131) ticks=readchar(demo);
    else
    { endofdemo=1;
      return;
    }
  }
}

int keyheld(int k)
{ return keys[k] && 1;
}

void refreshinput()
{ int i;

  if(demostat==PLAYBACK) readdemo();
  else for(i=0; i<128; i++) keys[i]=key[i];
  if(demostat==RECORD) writedemo();
}

void opendemo(char *s, int mode)
{ strcpy(demoname, s);
  demostat=mode;
}

void startdemo()
{ if(demostat)
  { demo=fopen(demoname, (demostat==PLAYBACK)?"rb":"wb");
    if(demostat==PLAYBACK) readstate(demo);
    else writestate(demo);
  }
}

void stopdemo()
{ if(demo)
  { writechar(255, demo);
    fclose(demo);
  }
}
