#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "misc.h"

#ifdef DEBUG
static int total;

FILE *debug;
#endif

void *zmalloc(int size)
{ void *p;

  assert(p=malloc(size));
  memset(p, 0, size);

#ifdef DEBUG
  debuglog("zmalloc %d (%d)\n", size, total+=size);
#endif

  return p;
}

void *zcalloc(int count, int size)
{ void *p;

  assert(p=malloc(count*size));
  memset(p, 0, count*size);

#ifdef DEBUG
  debuglog("zcalloc %d*%d=%d (%d)\n", count, size,
                                      count*size, total+=count*size);
#endif

  return p;
}

void zfree(void *p)
{ free(p);
}

unsigned int decodechar(unsigned char *d)
{ return *d;
}

unsigned int decodeword(unsigned char *d)
{ return decodechar(d)+decodechar(d+1)*256;
}

unsigned int decodelong(unsigned char *d)
{ return decodeword(d)+decodeword(d+2)*65536;
}

unsigned int readchar(FILE *f)
{ unsigned char c;
  fread(&c, 1, 1, f);
  return c;
}

unsigned int readword(FILE *f)
{ int t=readchar(f);
  return t+readchar(f)*256;
}

unsigned int readlong(FILE *f)
{ int t=readword(f);
  return t+readword(f)*65536;
}

void writechar(unsigned char c, FILE *f)
{ fwrite(&c, 1, 1, f);
}

void writeword(unsigned int w, FILE *f)
{ writechar(w%256, f);
  writechar((w/256)%256, f);
}

void writelong(unsigned int l, FILE *f)
{ writeword(l%65536, f);
  writeword((l/65536)%65536, f);
}
