#ifndef _MISC_H
#define _MISC_H

#include <stdarg.h>
#include <stdio.h>

extern FILE *debug;

void *zmalloc(int size);
void *zcalloc(int count, int size);
void zfree(void *p);
unsigned int decodechar(unsigned char *d);
unsigned int decodeword(unsigned char *d);
unsigned int decodelong(unsigned char *d);
unsigned int readchar(FILE *f);
unsigned int readword(FILE *f);
unsigned int readlong(FILE *f);
void writechar(unsigned char c, FILE *f);
void writeword(unsigned int w, FILE *f);
void writelong(unsigned int l, FILE *f);

#ifdef DEBUG
inline void debuglog(char *fmt, ...)
{ va_list args;

  va_start(args, fmt);
  vfprintf(debug, fmt, args);
  va_end(args);

  fflush(debug);
}
#else
inline void debuglog(char *fmt, ...){}
#endif

#endif
