#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <zlib.h>

char filelist[1024][16];
char filelabel[1024][32];
long filesize[1024];
long nfiles=0,pindex=8;

void makeoutputfile(char *fn)
{ FILE *f;

  f=fopen(fn,"wb");
  fwrite("IPUD",8,1,f);
  fclose(f);
}

void getfilelist(char *fn)
{ char s[64];
  char *l;
  FILE *f;
  int i;

  f=fopen(fn,"r");
  while(!feof(f))
  { fgets(s,64,f);
    l=strchr(s,' ')+1;
    for(i=0; i<64; i++)
      if(s[i]==10 || s[i]==13 || (!s[i-1] && i)) s[i]=0;
    l[-1]=0;
    for(i=0; i<12; i++) filelist[nfiles][i]=s[i];
    strcpy(filelabel[nfiles],l);
    nfiles++;
  }
  fclose(f);
}

void writefiledata(char *fn)
{ FILE *f, *f2;
  unsigned long i, size;
  Byte *buffer, *buffer2;

  f=fopen(fn,"ab");
  for(i=0; i<nfiles; i++)
  { f2=fopen(filelist[i], "rb");
    fseek(f2, 0, SEEK_END); 
    size=ftell(f2);
    buffer=malloc(size);
    buffer2=malloc(size*2);
    fseek(f2, 0, SEEK_SET);
    fread(buffer, size, 1, f2);
    fclose(f2);
    filesize[i]=size*2;
    compress(buffer2, (uLong *)(filesize+i), buffer, size);
    printf("compressed %s from %lu to %lu\n", filelist[i], size, filesize[i]);
    fwrite(&size, 4, 1, f);
    fwrite(buffer2, filesize[i], 1, f);
    free(buffer);
    free(buffer2);
    filesize[i]+=4;
    pindex+=filesize[i];
  }
  fclose(f);
}

void updateheader(char *fn)
{ FILE *f;

  f=fopen(fn,"rb+");
  fseek(f,4,SEEK_SET);
  fwrite(&pindex,4,1,f);
  fclose(f);
}

void makeindex(char *fn)
{ FILE *f;
  int i;
  long cp=8;

  f=fopen(fn,"ab");
  for(i=0; i<nfiles; i++)
  { fwrite(filelabel[i],32,1,f);
    fwrite(&cp,4,1,f);
    fwrite(&(filesize[i]),4,1,f);
    cp+=filesize[i];
  }
  fclose(f);
}

int main(int argc, char **argv)
{ printf("Pud Maker");
  assert(argc==3);
  getfilelist(argv[1]);
  makeoutputfile(argv[2]);
  writefiledata(argv[2]);
  updateheader(argv[2]);
  makeindex(argv[2]);

  return !argc;
}
